#include <iostream>
#include <cstdio>
#include "hilotunel.h"

using namespace std;

void PintaNave(COORD c1, COORD c2) {
    HANDLE hMutex;
    hMutex = OpenMutex(MUTEX_ALL_ACCESS, FALSE, "MutexAccesoPantalla");

    if(WaitForSingleObject(hMutex, INFINITE) == WAIT_OBJECT_0){
        SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), c1);
        printf(" ");
        SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), c2);
        printf("\30");
        ReleaseMutex(hMutex);
    }
    CloseHandle(hMutex);
}

// Definir dato miembro esttico, comn para todos los hilos.
bool HiloPantalla::salir = false;

int main()
{
    COORD dwPos = {52, 0};
    char cad[] =  "Pulsa ESC para salir";
    CONSOLE_CURSOR_INFO ci = {100, FALSE};

    SetConsoleCursorInfo(GetStdHandle(STD_OUTPUT_HANDLE), &ci);
    // Activar el cdigo de pgina "latn", para que se muestren correctamente acentos, la letra , etc:
    SetConsoleOutputCP(1250);

    SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE), dwPos);
    WriteConsole(GetStdHandle(STD_OUTPUT_HANDLE), cad, strlen(cad), 0, 0);

    Tunel tunel(10, 140);

    do {
        // Nada que hacer en este bucle, slo esperar a que se pulse escape.
    } while(!tunel.Escape());


    tunel.Terminar();
    return 0;
}
